#ifndef __INC_METIN2_ITEM_LENGTH_H__
#define __INC_METIN2_ITEM_LENGTH_H__

#include "CommonDefines.h"
#include <string>
enum EItemMisc
{
	ITEM_NAME_MAX_LEN			= 48,
	ITEM_VALUES_MAX_NUM			= 6,
	ITEM_SMALL_DESCR_MAX_LEN	= 256,
	ITEM_LIMIT_MAX_NUM			= 2,
	ITEM_APPLY_MAX_NUM			= 3,
	ITEM_SOCKET_MAX_NUM			= 3,
	ITEM_ATTRIBUTE_NORM_NUM		= 5,
	ITEM_ATTRIBUTE_RARE_NUM		= 2,

	ITEM_ATTRIBUTE_NORM_START	= 0,
	ITEM_ATTRIBUTE_NORM_END		= ITEM_ATTRIBUTE_NORM_START + ITEM_ATTRIBUTE_NORM_NUM,

	ITEM_ATTRIBUTE_RARE_START	= ITEM_ATTRIBUTE_NORM_END,
	ITEM_ATTRIBUTE_RARE_END		= ITEM_ATTRIBUTE_RARE_START + ITEM_ATTRIBUTE_RARE_NUM,

	ITEM_ATTRIBUTE_MAX_NUM		= ITEM_ATTRIBUTE_RARE_END, // 7
	ITEM_ATTRIBUTE_MAX_LEVEL	= 5,
#ifdef ENABLE_ATTR_COSTUMES
	COSTUME_ATTRIBUTE_MAX_LEVEL = 5,
#endif
#ifdef ENABLE_SWITCHBOT
	MAX_NORM_ATTR_NUM			= 5,
	MAX_RARE_ATTR_NUM			= 2,
#endif
	ITEM_AWARD_WHY_MAX_LEN		= 50,
	REFINE_MATERIAL_MAX_NUM		= 5,

	ITEM_ELK_VNUM				= 50026,
};

const BYTE ITEM_SOCKET_REMAIN_SEC = 0;
enum EItemValueIdice
{
	ITEM_VALUE_DRAGON_SOUL_POLL_OUT_BONUS_IDX = 0,
	ITEM_VALUE_CHARGING_AMOUNT_IDX = 0,
	ITEM_VALUE_SECONDARY_COIN_UNIT_IDX = 0,
};
enum EItemDragonSoulSockets
{
	ITEM_SOCKET_DRAGON_SOUL_ACTIVE_IDX = 2,
	ITEM_SOCKET_CHARGING_AMOUNT_IDX = 2,
};
//  ̰ ģ ƴϾ?
// ߿  Ȯϸ ¼  -_-;;;
enum EItemUniqueSockets
{
	ITEM_SOCKET_UNIQUE_SAVE_TIME = ITEM_SOCKET_MAX_NUM - 2,
	ITEM_SOCKET_UNIQUE_REMAIN_TIME = ITEM_SOCKET_MAX_NUM - 1
};

enum EItemTypes
{
    ITEM_NONE,              //0
    ITEM_WEAPON,            //1//
    ITEM_ARMOR,             //2//
    ITEM_USE,               //3// 
    ITEM_AUTOUSE,           //4
    ITEM_MATERIAL,          //5
    ITEM_SPECIAL,           //6 // 
    ITEM_TOOL,              //7
    ITEM_LOTTERY,           //8//
    ITEM_ELK,               //9//
    ITEM_METIN,             //10
    ITEM_CONTAINER,         //11
    ITEM_FISH,              //12//
    ITEM_ROD,               //13
    ITEM_RESOURCE,          //14
    ITEM_CAMPFIRE,          //15
    ITEM_UNIQUE,            //16
    ITEM_SKILLBOOK,         //17
    ITEM_QUEST,             //18
    ITEM_POLYMORPH,         //19
    ITEM_TREASURE_BOX,      //20//
    ITEM_TREASURE_KEY,      //21// 
    ITEM_SKILLFORGET,       //22
    ITEM_GIFTBOX,           //23
    ITEM_PICK,              //24
    ITEM_HAIR,              //25//Ӹ
    ITEM_TOTEM,             //26//
	ITEM_BLEND,				//27//ɶ ϰ Ӽ ٴ ๰
	ITEM_COSTUME,			//28//ڽ  (2011 8 ߰ ڽ ýۿ )
	ITEM_DS,				//29 //ȥ
	ITEM_SPECIAL_DS,		//30 // Ư ȥ (DS_SLOT ϴ UNIQUE ̶ ϸ )
	ITEM_EXTRACT,			//31 ⵵.
	ITEM_SECONDARY_COIN,	//32 ?? ??
	ITEM_RING,				//33 
	ITEM_BELT,				//34 Ʈ
	ITEM_SOUL,	
#ifdef __ATTR_TRANSFER_SYSTEM__
	ITEM_TRANSFER_SCROLL,
#endif
#ifdef ENABLE_NEW_PET_EDITS
	ITEM_TYPE_PET,
#endif
#ifdef ENABLE_ITEMSHOP_ITEM
	ITEM_TYPE_ISHOP
#endif
};

enum EMetinSubTypes
{
	METIN_NORMAL,
	METIN_GOLD,
};

enum EWeaponSubTypes
{
	WEAPON_SWORD,
	WEAPON_DAGGER,
	WEAPON_BOW,
	WEAPON_TWO_HANDED,
	WEAPON_BELL,
	WEAPON_FAN,
	WEAPON_ARROW,
	WEAPON_MOUNT_SPEAR,
#ifdef ENABLE_WOLFMAN_CHARACTER
	WEAPON_CLAW,
#endif
	WEAPON_NUM_TYPES,
};

enum EArmorSubTypes
{
	ARMOR_BODY,
	ARMOR_HEAD,
	ARMOR_SHIELD,
	ARMOR_WRIST,
	ARMOR_FOOTS,
	ARMOR_NECK,
	ARMOR_EAR,
#ifdef ENABLE_PENDANT
	ARMOR_PENDANT,
#endif
	ARMOR_NUM_TYPES
};

enum ECostumeSubTypes
{
	COSTUME_BODY = ARMOR_BODY,			// [߿!!] ECostumeSubTypes enum value   EArmorSubTypes װͰ ƾ .
	COSTUME_HAIR = ARMOR_HEAD,			// ̴ ڽ ۿ ߰ Ӽ ̰ڴٴ  û    Ȱϱ .
#ifdef ENABLE_MOUNT_COSTUME_SYSTEM
	COSTUME_MOUNT,
#endif
#ifdef ENABLE_ACCE_SYSTEM
	COSTUME_ACCE	= 3,
#endif
#ifdef ENABLE_WEAPON_COSTUME_SYSTEM
	COSTUME_WEAPON	= 4,
#endif
#ifdef ENABLE_STOLE_COSTUME
	COSTUME_STOLE = 5,
#endif
#ifdef ENABLE_COSTUME_PET
	COSTUME_PET_SKIN = 6,
#endif
#ifdef ENABLE_COSTUME_MOUNT
	COSTUME_MOUNT_SKIN = 7,
#endif
#ifdef ENABLE_COSTUME_EFFECT
	COSTUME_EFFECT_BODY = 8,
	COSTUME_EFFECT_WEAPON = 9,
#endif
#ifdef ENABLE_RUNE_SYSTEM
	RUNE_SLOT1,
	RUNE_SLOT2,
	RUNE_SLOT3,
	RUNE_SLOT4,
	RUNE_SLOT5,
	RUNE_SLOT6,
	RUNE_SLOT7,
#endif
	COSTUME_NUM_TYPES,
};

#ifdef ENABLE_SOUL_SYSTEM
enum ESoulSubTypes
{
	RED_SOUL,
	BLUE_SOUL,
	SOUL_MAX_NUM,
};
#endif

enum EDragonSoulSubType
{
	DS_SLOT1,
	DS_SLOT2,
	DS_SLOT3,
	DS_SLOT4,
	DS_SLOT5,
	DS_SLOT6,
	DS_SLOT_MAX,
};

#ifdef ENABLE_ACCE_SYSTEM
enum EAcceInfo
{
	ACCE_GRADE_VALUE_FIELD = 0,
	ACCE_ABSORPTION_SOCKET = 0,
	ACCE_ABSORBED_SOCKET = 1,
	ACCE_GRADE_1_ABS = 1,
	ACCE_GRADE_2_ABS = 5,
	ACCE_GRADE_3_ABS = 10,
	ACCE_GRADE_4_ABS_MIN = 11,
	ACCE_GRADE_4_ABS_MAX = 25,
	ACCE_GRADE_4_ABS_MAX_COMB = 19,
	ACCE_GRADE_4_ABS_RANGE = 5,
	ACCE_EFFECT_FROM_ABS = 19,
	ACCE_CLEAN_ATTR_VALUE0 = 7,
	ACCE_WINDOW_MAX_MATERIALS = 2,
	ACCE_GRADE_1_PRICE = 20000000,
	ACCE_GRADE_2_PRICE = 40000000,
	ACCE_GRADE_3_PRICE = 60000000,
	ACCE_GRADE_4_PRICE = 90000000,
#ifdef ENABLE_STOLE_COSTUME
	COSTUME_STOLE_GRADE_1_PRICE = 100000000,
	COSTUME_STOLE_GRADE_2_PRICE = 150000000,
	COSTUME_STOLE_GRADE_3_PRICE = 250000000,
#endif
	ACCE_COMBINE_GRADE_1 = 80,
	ACCE_COMBINE_GRADE_2 = 70,
	ACCE_COMBINE_GRADE_3 = 50,
	ACCE_COMBINE_GRADE_4 = 30,
};
#endif

enum EDragonSoulGradeTypes
{
	DRAGON_SOUL_GRADE_NORMAL,
	DRAGON_SOUL_GRADE_BRILLIANT,
	DRAGON_SOUL_GRADE_RARE,
	DRAGON_SOUL_GRADE_ANCIENT,
	DRAGON_SOUL_GRADE_LEGENDARY,
#ifdef ENABLE_DS_GRADE_MYTH
	DRAGON_SOUL_GRADE_MYTH,
#endif
	DRAGON_SOUL_GRADE_MAX,

};

enum EDragonSoulStepTypes
{
	DRAGON_SOUL_STEP_LOWEST,
	DRAGON_SOUL_STEP_LOW,
	DRAGON_SOUL_STEP_MID,
	DRAGON_SOUL_STEP_HIGH,
	DRAGON_SOUL_STEP_HIGHEST,
	DRAGON_SOUL_STEP_MAX,
};
#define DRAGON_SOUL_STRENGTH_MAX 7

enum EDSInventoryMaxNum
{
	DRAGON_SOUL_INVENTORY_MAX_NUM = 300 + (DS_SLOT_MAX * DRAGON_SOUL_GRADE_MAX * DRAGON_SOUL_BOX_SIZE),
};

enum EFishSubTypes
{
	FISH_ALIVE,
	FISH_DEAD,
};

enum EResourceSubTypes
{
	RESOURCE_FISHBONE,
	RESOURCE_WATERSTONEPIECE,
	RESOURCE_WATERSTONE,
	RESOURCE_BLOOD_PEARL,
	RESOURCE_BLUE_PEARL,
	RESOURCE_WHITE_PEARL,
	RESOURCE_BUCKET,
	RESOURCE_CRYSTAL,
	RESOURCE_GEM,
	RESOURCE_STONE,
	RESOURCE_METIN,
	RESOURCE_ORE,
};

enum EUniqueSubTypes
{
	UNIQUE_NONE,
	UNIQUE_BOOK,
	UNIQUE_SPECIAL_RIDE,
	UNIQUE_SPECIAL_MOUNT_RIDE,
#ifdef ENABLE_NEW_UNIQUE_WEAR_LIMITED
	UNIQUE_PVM,
	UNIQUE_PVP,
#endif
};

enum EUseSubTypes
{
	USE_POTION,					// 0
	USE_TALISMAN,
	USE_TUNING,
	USE_MOVE,
	USE_TREASURE_BOX,
	USE_MONEYBAG,
	USE_BAIT,
	USE_ABILITY_UP,
	USE_AFFECT,
	USE_CREATE_STONE,
	USE_SPECIAL,				// 10
	USE_POTION_NODELAY,
	USE_CLEAR,
	USE_INVISIBILITY,
	USE_DETACHMENT,
	USE_BUCKET,
	USE_POTION_CONTINUE,
	USE_CLEAN_SOCKET,
	USE_CHANGE_ATTRIBUTE,
	USE_ADD_ATTRIBUTE,
	USE_ADD_ACCESSORY_SOCKET,	// 20
	USE_PUT_INTO_ACCESSORY_SOCKET,
	USE_ADD_ATTRIBUTE2,
	USE_RECIPE,
	USE_CHANGE_ATTRIBUTE2,
	USE_BIND,
	USE_UNBIND,
	USE_TIME_CHARGE_PER,
	USE_TIME_CHARGE_FIX,				// 28
	USE_PUT_INTO_BELT_SOCKET,			// 29 Ʈ Ͽ   ִ 
	USE_PUT_INTO_RING_SOCKET,			// 30  Ͽ   ִ  (ũ  ,  ߰  )
	USE_CHANGE_COSTUME_ATTR,			// 31
	USE_RESET_COSTUME_ATTR,				// 32
	USE_UNK33,							// 33
	USE_CHANGE_ATTRIBUTE_PLUS,			// 34
#ifdef ATTR_LOCK
	USE_ADD_ATTRIBUTE_LOCK,				// 35
	USE_CHANGE_ATTRIBUTE_LOCK,			// 36
	USE_DELETE_ATTRIBUTE_LOCK,			// 37
#endif
#ifdef ENABLE_ATTR_COSTUMES
	USE_CHANGE_ATTR_COSTUME,			// 38
	USE_ADD_ATTR_COSTUME1,				// 39
	USE_ADD_ATTR_COSTUME2,				// 40
	USE_REMOVE_ATTR_COSTUME,			// 41
#endif
#ifdef ENABLE_DS_ENCHANT
	USE_DS_ENCHANT,						// 42
#endif
#ifdef ENABLE_NEW_PET_EDITS
	USE_PET_REVIVE,						// 43
	USE_PET_ENCHANT,					// 44
#endif
#ifdef ENABLE_REMOTE_ATTR_SASH_REMOVE
	USE_ATTR_SASH_REMOVE,				// 45
#endif
#ifdef ENABLE_RUNE_SYSTEM
	USE_RUNE_PERC_CHARGE,				// 46
#endif
#ifdef ENABLE_NEW_USE_POTION
	USE_NEW_POTIION,					// 47
#endif
#ifdef ENABLE_STOLE_COSTUME
	USE_ENCHANT_STOLE,					// 48
#endif
	USE_FISH,							// 49
};

enum EExtractSubTypes
{
	EXTRACT_DRAGON_SOUL,
	EXTRACT_DRAGON_HEART,
};

enum EAutoUseSubTypes
{
	AUTOUSE_POTION,
	AUTOUSE_ABILITY_UP,
	AUTOUSE_BOMB,
	AUTOUSE_GOLD,
	AUTOUSE_MONEYBAG,
	AUTOUSE_TREASURE_BOX
};

enum EMaterialSubTypes
{
	MATERIAL_LEATHER,
	MATERIAL_BLOOD,
	MATERIAL_ROOT,
	MATERIAL_NEEDLE,
	MATERIAL_JEWEL,
	MATERIAL_DS_REFINE_NORMAL,
	MATERIAL_DS_REFINE_BLESSED,
	MATERIAL_DS_REFINE_HOLLY,
};

enum ESpecialSubTypes
{
	SPECIAL_MAP,
	SPECIAL_KEY,
	SPECIAL_DOC,
	SPECIAL_SPIRIT,
};

enum EToolSubTypes
{
	TOOL_FISHING_ROD
};

enum ELotterySubTypes
{
	LOTTERY_TICKET,
	LOTTERY_INSTANT
};

enum EItemFlag
{
	ITEM_FLAG_REFINEABLE		= (1 << 0),
	ITEM_FLAG_SAVE			= (1 << 1),
	ITEM_FLAG_STACKABLE		= (1 << 2),	//  ĥ  
	ITEM_FLAG_COUNT_PER_1GOLD	= (1 << 3),
	ITEM_FLAG_SLOW_QUERY		= (1 << 4),
	ITEM_FLAG_UNUSED01		= (1 << 5),	// UNUSED
	ITEM_FLAG_UNIQUE		= (1 << 6),
	ITEM_FLAG_MAKECOUNT		= (1 << 7),
	ITEM_FLAG_IRREMOVABLE		= (1 << 8),
	ITEM_FLAG_CONFIRM_WHEN_USE	= (1 << 9),
	ITEM_FLAG_QUEST_USE		= (1 << 10),
	ITEM_FLAG_QUEST_USE_MULTIPLE	= (1 << 11),
	ITEM_FLAG_QUEST_GIVE		= (1 << 12),
	ITEM_FLAG_LOG			= (1 << 13),
	ITEM_FLAG_APPLICABLE		= (1 << 14),
};

enum EItemAntiFlag
{
	ITEM_ANTIFLAG_FEMALE	= (1 << 0), //   Ұ
	ITEM_ANTIFLAG_MALE		= (1 << 1), //   Ұ
	ITEM_ANTIFLAG_WARRIOR	= (1 << 2), //   Ұ
	ITEM_ANTIFLAG_ASSASSIN	= (1 << 3), // ڰ  Ұ
	ITEM_ANTIFLAG_SURA		= (1 << 4), //   Ұ
	ITEM_ANTIFLAG_SHAMAN	= (1 << 5), //   Ұ
	ITEM_ANTIFLAG_GET		= (1 << 6), //   
	ITEM_ANTIFLAG_DROP		= (1 << 7), //   
	ITEM_ANTIFLAG_SELL		= (1 << 8), //   
	ITEM_ANTIFLAG_EMPIRE_A	= (1 << 9), // A   Ұ
	ITEM_ANTIFLAG_EMPIRE_B	= (1 << 10), // B   Ұ
	ITEM_ANTIFLAG_EMPIRE_C	= (1 << 11), // C   Ұ
	ITEM_ANTIFLAG_SAVE		= (1 << 12), //  
	ITEM_ANTIFLAG_GIVE		= (1 << 13), // ŷ Ұ
	ITEM_ANTIFLAG_PKDROP	= (1 << 14), // PK  
	ITEM_ANTIFLAG_STACK		= (1 << 15), // ĥ  
	ITEM_ANTIFLAG_MYSHOP	= (1 << 16), //   ø  
	ITEM_ANTIFLAG_SAFEBOX	= (1 << 17), // â   
#ifdef ENABLE_WOLFMAN_CHARACTER
	ITEM_ANTIFLAG_WOLFMAN	= (1 << 18), //   Ұ
#endif
};

enum EItemWearableFlag
{
	WEARABLE_BODY	= (1 << 0),
	WEARABLE_HEAD	= (1 << 1),
	WEARABLE_FOOTS	= (1 << 2),
	WEARABLE_WRIST	= (1 << 3),
	WEARABLE_WEAPON	= (1 << 4),
	WEARABLE_NECK	= (1 << 5),
	WEARABLE_EAR	= (1 << 6),
	WEARABLE_UNIQUE	= (1 << 7),
	WEARABLE_SHIELD	= (1 << 8),
	WEARABLE_ARROW	= (1 << 9),
	WEARABLE_HAIR	= (1 << 10),
	WEARABLE_ABILITY		= (1 << 11),
	WEARABLE_COSTUME_BODY	= (1 << 12),
#ifdef ENABLE_PENDANT
	WEARABLE_PENDANT		= (1 << 13),
#endif
};

enum ELimitTypes
{
	LIMIT_NONE,

	LIMIT_LEVEL,
	LIMIT_STR,
	LIMIT_DEX,
	LIMIT_INT,
	LIMIT_CON,
	LIMIT_PCBANG,

	///  ο   ǽð ð  (socket0 Ҹ ð : unix_timestamp Ÿ)
	LIMIT_REAL_TIME,

	///   ó (Ȥ )   Ÿ Ÿ̸ 
	///    socket0 밡ɽð(ʴ, 0̸  limit value )  ִٰ
	///   socket1  Ƚ  socket0 unix_timestamp Ÿ Ҹð .
	LIMIT_REAL_TIME_START_FIRST_USE,

	///      ð Ǵ 
	/// socket0  ð ʴ . (   ش  0̸  limit value socket0 )
	LIMIT_TIMER_BASED_ON_WEAR,
	LIMIT_UNIQUE_UNLIMITED,
	LIMIT_MAX_NUM
};

enum EAttrAddonTypes
{
	ATTR_ADDON_NONE,
	// positive values are reserved for set
	ATTR_DAMAGE_ADDON = -1,
};

enum ERefineType
{
	REFINE_TYPE_NORMAL,
	REFINE_TYPE_NOT_USED1,
	REFINE_TYPE_SCROLL,
	REFINE_TYPE_HYUNIRON,
	REFINE_TYPE_MONEY_ONLY,
	REFINE_TYPE_MUSIN,
	REFINE_TYPE_BDRAGON,
#ifdef ENABLE_SOUL_SYSTEM
	REFINE_TYPE_SOUL,
#endif

};












#ifdef ENABLE_RARITY_SYSTEM
enum EItemRarity {
	ITEM_COMMON,
	ITEM_EPIC,
	ITEM_LEGENDARY,
	ITEM_ANTIQUE,
	ITEM_MISTIC,
};
#endif

#ifdef ENABLE_NEW_EXTRA_BONUS
enum ENewExtraBonus {
	NEW_EXTRA_BONUS_COUNT = 2,
};
#endif

#ifdef ENABLE_ITEM_EXTRA_PROTO
enum class EItemExtraProto {
	ITEM_VNUM,
#ifdef ENABLE_RARITY_SYSTEM
	ITEM_RARITY,
#endif
#ifdef ENABLE_NEW_EXTRA_BONUS
	ITEM_EXTRA_BONUS_START,
	ITEM_EXTRA_BONUS_TYPE0 = ITEM_EXTRA_BONUS_START,
	ITEM_EXTRA_BONUS_VALUE0,
	ITEM_EXTRA_BONUS_TYPE1,
	ITEM_EXTRA_BONUS_VALUE1,
	ITEM_EXTRA_BONUS_END = ITEM_EXTRA_BONUS_START + (NEW_EXTRA_BONUS_COUNT * 2) - 1,
#endif
	//add new values here:


	//this is always the last 
	//value of the enum
	ITEM_EXTRA_PROTO_FIELD_COUNT,
};
#endif






#endif //__INC_METIN2_ITEM_LENGTH_H__

